// Grafikrutiner
#include <stdlib.h>
#include <stdio.h>
#include <dos.h>
#include <iostream.h>

typedef unsigned char byte;
typedef unsigned int word;
typedef unsigned char pal[256][3];

word VGA=0xA000;

// GRAFIK

void mode(int);                              // stter grafiklge
void loadcel(char *fnamn,byte *where,pal &palett);  // laddar in en CEL
void makevirt(word &adr,byte *&virscr);  // skapar en virtuell skrm
void killvirt(byte *kill);               // raderar en   ---||---
void screencopy(word,word);                // kopierar skrmar hit och dit
void screenpaste(int x1,int y1,int x2,int y2,int x3,int y3,word source,word dest);
void cls(byte,word);                         // rensar skrmen med valfri frg
void putpixel(word,word,byte,word);          // ritar en pixel
byte getpixel(word,word,word);                // ger pixelfrgen
void horizontal(word x,word y,word length,byte col,word where);
void vertical(word x,word y,word length,byte col,word where);
void line(word,word,word,word,byte,word);    // drar ett streck
void box(word,word,word,word,byte,word);     // ritar en lda
void bar(word,word,word,word,byte,word);     // ritar en ifylld lda
void waitvbl();                              // vntar ut elektronstrlen

// ICONS 24x20

void makeicons(word &adr,byte *&ICON);   // skapar en ikonbank
void killicons(byte *kill);              // raderar en --||--
void loadicons(char *fnamn,byte *ICON,pal &palett); // laddar in en ICO-fil
void puticon(int,int,int,word,word);         // ritar ut en ikon
void puticon_F(int,int,int,word,word);         // ritar ut en ikon
void puticon_M(int,int,int,word,word);	     // ritar ut en ikon utan bakgrundsfrgen
void puticon_MF(int,int,int,word,word);	     // ritar ut en ikon utan bakgrundsfrgen

// ICONS 32x32

void makeicons32(word &adr,byte *&ICON);   // skapar en ikonbank
void killicons32(byte *kill);              // raderar en --||--
void loadicons32(char *fnamn,byte *ICON,pal &palette); // laddar in en ICO-fil
void puticon32(int,int,int,word,word);         // ritar ut en ikon
void puticon_M32(int,int,int,word,word);	     // ritar ut en ikon utan bakgrundsfrgen

// UNDERFUNKTIONER TILL FUNKTIONERNA

int  sgn(int);                               // returnerar tecknet p en int

void mode(int mode)
// stter skrmlge, tex 3=text; 19=MCGA
{
  asm {
    MOV ax,mode         // stoppar mode i AX-registret
    INT 0x10            // anvnder innehllet i AX fr att initiera
  }                     // grafiklge (3=text, 19=grafik (MCGA))
}

void loadcel(char *fnamn,byte *where,pal &palett)
// laddar in en CEL-bild i where med paletten i pal
{
  FILE *fp;
  int width[2],height[2];

  fp=fopen(fnamn,"rb");
  fseek(fp,2,SEEK_SET);
  fread(width,2,1,fp);
  fread(height,2,1,fp);
  fseek(fp,32,SEEK_SET);
  fread(palett,sizeof(pal),1,fp);
  fseek(fp,4,SEEK_CUR);
  for(int r=0;r<height[0];r++)
    fread(where+r*320,width[0],1,fp);
  fclose(fp);
}

void cls(byte col,word where)
// rensar skrmen med frg 'col'
{
  asm {
    MOV   ax,[where]      // stoppar adressen where i AX
    MOV   es,ax           // stoppar AX i ES
    XOR   di,di           // nollar DI
    MOV   al,[col]        // stoppar frgnummret i AL
    MOV   ah,al           // stoppar AL i AH
    MOV   cx,32000;       // flyttar 32000 words = 64000 bytes = hela skrmen
    REP   stosw           // flyttar...
  }
}

void makevirt(word &adr,byte *&virscr)
// skapar en virtuell skrm som kan kommas t med hjlp av
// 'adr' eller virscr istllet fr VGA
{
  virscr = (byte *) malloc(64010);

  // kolla alltid om det finns tillrckligt med minne!
  if (virscr == NULL)
  {
    cout << "Not enough memory. 64010 b wanted.";
    free(virscr);
    exit(1);
  }

  adr = FP_SEG(virscr);
}

void killvirt(byte *kill)
// frigr minnet som skrmen 'adr' upptog
{
  free(kill);
}

void screencopy(word source,word dest)
// kopierar hela sources innehll till dest
{
  asm {
    PUSH    ds           // sparar DataSegmentet
    MOV     ax, [dest]   // kopierar destinationspekaren till AX
    MOV     es, ax       // stoppar AX i ES
    MOV     ax, [source] // kopierar kllpekaren till AX
    MOV     ds, ax       // stoppar AX i DS
    XOR     si, si       // nollar SI
    XOR     di, di       // nollar DI
    MOV     cx, 32000    // 32000 words skall kopieras
    REP     movsw        // kopierar words cx gnger
    POP     ds           // terstller DS
  }
}

void screenpaste(int x1,int y1,int x2,int y2,int x3,int y3,word source,word dest)
// kopierar rektanglen (x1,y1)-(x2,y2) frn source till (x3,y3) dest
{
  int dpos,spos;

  spos=x1+y1*320;
  dpos=x3+y3*320;

  asm {
    PUSH  ds
    MOV   ax,x2
    SUB   ax,x1
    INC   ax
    MOV   bx,ax
    SHR   ax,1
    MOV   x2,ax

    MOV   ax,321
    SUB   ax,bx
    MOV   x1,ax

    MOV   ax,y2
    SUB   ax,y1
    MOV   y2,ax

    MOV   ax,[source]
    MOV   ds,ax
    MOV   si,spos
    MOV   ax,[dest]
    MOV   es,ax
    MOV   di,dpos
    CLD
    XOR   bx,bx
  }
 _Rita: asm{
    MOV   cx,x2
    REP   movsw
    INC   bx
    ADD   di,x1
    ADD   si,x1
    CMP   bx,y2
    JL   _Rita

    POP   ds
  }
}

void waitvbl()
// vntar ut nrmaste elektronsvep
{
  _DX = 0x03DA;

  l1: asm {
	IN   al,dx
	AND  al,0x08
	JNZ  l1
      }

  l2: asm {
	IN   al,dx
	AND  al,0x08
	JZ   l2
      }
}

void horizontal(word x,word y,word length,byte col,word where)
// drar en horisontell linje med frg 'col' i (x;y)
{
  asm {
    MOV   ax,[where]
    MOV   es,ax
    MOV   bx,[x]
    MOV   dx,[y]
    MOV   di,bx
    MOV   bx, dx    //              {; bx = dx}
    SHL   dx, 8
    SHL   bx, 6
    ADD   dx, bx    //              {; dx = dx + bx (ie y*320)}
    ADD   di, dx    //              {; finalise location}
    MOV   al, [col]
    MOV   cx, length
    REP STOSB
  }
}

void vertical(word x,word y,byte col,word where)
// drar en vertikal linje med frg 'col' i (x;y)
{
  asm {
    MOV   ax,[where]
    MOV   es,ax
    MOV   bx,[x]
    MOV   dx,[y]
    MOV   di,bx
    MOV   bx, dx    //              {; bx = dx}
    SHL   dx, 8
    SHL   bx, 6
    ADD   dx, bx    //              {; dx = dx + bx (ie y*320)}
    ADD   di, dx    //              {; finalise location}
    MOV   al, [col]
    MOV   cx, y
    }
   _Rita: asm {
    STOSB
    add   di, 319
    inc   cx
    cmp   cx, 200
    jnz   _Rita
  }
}

void putpixel(word x,word y,byte col,word where)
// ritar en pixel med frg 'col' i (x;y)
{
  asm {
    mov ax, [where]       //ax now hold the address to the monitor.
    mov es, ax   	//this moves the address into memory.
    mov cx, [y]    	//bx now holds the value for y.
    mov di, cx   	//di now holds the value for y.
    xchg cl,ch  	///This makes cx = y*256.
    shl di, 6    	//di now equals y*64
    add di, cx   	//di now equals (256+64)*y which is the same as: 320*y.
    add di, [x]    	//di now equals: y*320 + x
    mov al, [col]  	//al now holds the beam shooter value!
    mov [es:di],al      //This skips the interrupt, and writes to memory
  }
}

byte getpixel(word x,word y,word where)
// ger pixelfrgen i (x;y)
{
  int farg;
  asm {
    PUSH  ds
    MOV   ax, [where]
    MOV   ds, ax
    MOV   bx, [x]
    MOV   dx, [y]
    MOV   si, bx
    MOV   bx, dx    //              {; bx = dx}
    SHL   dx, 8
    SHL   bx, 6
    ADD   dx, bx    //              {; dx = dx + bx (ie y*320)}
    ADD   si, dx    //              {; finalise location}
    XOR	  ax,ax
    LODSB
    MOV   farg,ax
    POP   ds
  }
  return(farg);
}

int sgn(int a)
// returnerar -1, 0 eller +1 beroende p vrdet p 'a'
// anvnds av linefunktionen
{
  if (a > 0)  return +1;
  if (a < 0)  return -1;
  return 0;
}

void line(word a,word b,word c,word d,byte col,word where)
// drar ett streck frn (a;b) till (c;d) i frg 'col'
{
  int i,s,d1x,d1y,d2x,d2y,u,v,m,n;

  u = c - a;       // u = x2 - x1  (delta x)
  v = d - b;       // v = y2 - y1  (delta y)

  d1x = sgn(u);    // d1x = tecknet fr delta x
  d1y = sgn(v);    // d1y = tecknet fr delta y

  d2x = d1x;       // d2x = tecknet fr delta x
  d2y = 0;
  m = abs(u);      // m = positiv delta x
  n = abs(v);      // n = positiv delta y

  if (m <= n) {
    d2x = 0;
    d2y = sgn(v);  // d2y = tecknet fr delta y
    m = abs(v);    // m = positiv delta y
    n = abs(u);    // n = positiv delta x
  }
  s = m / 2;       // s = halva delta x/y

  for (i=0;i<m+1;i++) {
    putpixel(a,b,col,where);   // rita punkt i (a;b)
    s += n;
    if (s >= m) {
      s -= m;
      a += d1x;
      b += d1y;
    }
    else {
      a += d2x;
      b += d2y;
    }
  }
}

void box(word a,word b,word c,word d,byte col,word where)
// ritar en tom lda mellan (a;b) och (c:d) i frg 'col'
{
  line(a,b,a,d,col,where);
  line(a,d,c,d,col,where);
  line(c,d,c,b,col,where);
  line(c,b,a,b,col,where);
}

void bar(word a,word b,word c,word d,byte col,word where)
// ritar en fylld lda mellan (a;b) och (c:d) i frg 'col'
{
  int spos,bredd,lang;

  spos=a+b*320;
  bredd=c-a+1;
  lang=320-bredd;
  d++;

  asm {
    PUSH  ds
    MOV   ax,[where]
    MOV   es,ax
    MOV   di,spos
    XOR   ax,ax
  }
 _Rita: asm{
    MOV   al,col
    MOV   cx,bredd
    REP   stosb
    ADD   di,lang
    INC   b
    MOV   bx,b
    MOV   ax,d
    CMP   bx,ax
    JL   _Rita

    POP   ds
  }
}

void makeicons(word &adr,byte *&ICON)
// skapar en iconbank som kan kommas t med hjlp av
// 'adr' eller ICON
{
  ICON = (byte *) malloc(48010);

  // kolla alltid om det finns tillrckligt med minne!
  if (ICON == NULL)
  {
    cout << "Not enough memory. 48010 b wanted.";
    free(ICON);
    exit(1);
  }

  adr = FP_SEG(ICON);
}

void makeicons32(word &adr,byte *&ICON)
// skapar en iconbank som kan kommas t med hjlp av
// 'adr' eller ICON
{
  ICON = (byte *) malloc(61450);

  // kolla alltid om det finns tillrckligt med minne!
  if (ICON == NULL)
  {
    cout << "Not enough memory. 61450 b wanted.";
    free(ICON);
    exit(1);
  }

  adr = FP_SEG(ICON);
}

void killicons(byte *kill)
// frigr minnet som skrmen 'adr' upptog
{
  free(kill);
}

void killicons32(byte *kill)
// frigr minnet som skrmen 'adr' upptog
{
  free(kill);
}

void puticon(int n,int x,int y,word DEST,word ICON)
// ritar ut en ikon som den r frn banken ICON till skrmen DEST
{
  int ipos,pos,stbredd,bredd,sthojd,hojd,xadd;
  int kbredd;

  kbredd=0; bredd=24; hojd=20; stbredd=0; sthojd=0; xadd=296;
  if (y>180) hojd=200-y;
  if (y<0) { sthojd=-y; hojd=20+y; }
  if (x>296) { bredd=320-x; xadd=320-bredd; kbredd=24-bredd; }
  if (x<0) { stbredd=-x; xadd=296+stbredd; bredd=24-stbredd; kbredd=stbredd; }

  if (hojd>0 && bredd>0)
  {
    ipos=(n-1)*480+(sthojd<<3)+(sthojd<<4)+stbredd+4;
    pos=x+(y+sthojd)*320+stbredd;
    asm {
      PUSH  ds
      MOV   ax,[ICON]
      MOV   ds,ax
      MOV   si,ipos
      MOV   ax,[DEST]
      MOV   es,ax
      MOV   di,pos
      CLD
      XOR   bx,bx
      }
     _Rita: asm {
      MOV   cx,bredd
      REP   movsb
      ADD   si,kbredd
      INC   bx
      ADD   di,xadd
      CMP   bx,hojd
      JL   _Rita

      POP   ds
    }
  }
}

void puticon_F(int n,int x,int y,word DEST,word ICON)
// ritar ut en ikon som den r frn banken ICON till skrmen DEST
{
  int ipos,pos;

  ipos=(n-1)*480+4;
  pos=x+(y<<8)+(y<<6);
    asm {
      PUSH  ds
      MOV   ax,[ICON]
      MOV   ds,ax
      MOV   si,ipos
      MOV   ax,[DEST]
      MOV   es,ax
      MOV   di,pos
      CLD
      XOR   bx,bx
      }
     _Rita: asm {
      MOV   cx,12
      REP   movsw
      INC   bx
      ADD   di,296
      CMP   bx,20
      JL   _Rita

      POP   ds
    }
}

void puticon32(int n,int x,int y,word DEST,word ICON)
// ritar ut en ikon som den r frn banken ICON till skrmen DEST
{
  int ipos,pos;

  ipos=(n-1)*1024+4;
  pos=x+y*320;

  asm {
    PUSH  ds
    MOV   ax,[ICON]
    MOV   ds,ax
    MOV   si,ipos
    MOV   ax,[DEST]
    MOV   es,ax
    MOV   di,pos
    CLD
    XOR   bx,bx
    }
   _Rita: asm {
    MOV   cx,16
    REP   movsw
    ADD   di,288
    INC   bx
    CMP   bx,32
    JL   _Rita
    POP   ds
  }

}

void puticon_M32(int n,int x,int y,word DEST,word ICON)
// ritar ut en ikon utan bakgrundsfrg frn banken ICON till skrmen DEST
{
  int ipos,pos;

  ipos=(n-1)*1024+4;
  pos=x+(y<<8)+(y<<6);

    asm{
      PUSH  ds
      MOV   ax,[ICON]
      MOV   ds,ax
      MOV   si,ipos
      MOV   ax,[DEST]
      MOV   es,ax
      MOV   di,pos
      CLD
      XOR   bx,bx
      XOR   cx,cx
      JMP   _Rita
      }
     _NoMasking: asm{
      MOVSB
      JMP   _Next
      }
     _Rita: asm{
      MOV   dl,ds:[si]
      CMP   dl,0
      JNZ   _NoMasking
      INC   si
      INC   di
      }
     _Next: asm{
      INC   cx
      CMP   cx,32
      JNZ   _Rita

      XOR   cx,cx
      ADD   di,288
      INC   bx
      CMP   bx,32
      JNZ   _Rita
      POP   ds
    }
}

void puticon_M(int n,int x,int y,word DEST,word ICON)
// ritar ut en ikon utan bakgrundsfrg frn banken ICON till skrmen DEST
{
  int hojd=20,sthojd=0,kbredd=0,bredd=24,xadd=296,stbredd=0;

  if (y>180) hojd=200-y;
  if (y<0) sthojd=-y;
  if (x>296) { bredd=320-x; xadd=320-bredd; kbredd=24-bredd; }
  if (x<0) { stbredd=-x; xadd=296+stbredd; kbredd=stbredd; }

  if (hojd>0 && bredd>0 && sthojd<20 && stbredd<24)
  {
    int ipos,pos;

    ipos=(n-1)*480+4+(sthojd<<3)+(sthojd<<4)+stbredd;
    pos=x+(y<<8)+(y<<6)+(sthojd<<8)+(sthojd<<6)+stbredd;

    asm{
      PUSH  ds
      MOV   ax,[ICON]
      MOV   ds,ax
      MOV   si,ipos
      MOV   ax,[DEST]
      MOV   es,ax
      MOV   di,pos
      CLD
      MOV   bx,sthojd
      MOV   cx,stbredd
      JMP   _Rita
      }
     _NoMasking: asm{
      MOVSB
      JMP   _Next
      }
     _Rita: asm{
      MOV   dl,ds:[si]
      CMP   dl,0
      JNZ   _NoMasking
      INC   si
      INC   di
      }
     _Next: asm{
      INC   cx
      CMP   cx,bredd
      JNZ   _Rita
      ADD   si,kbredd

      INC   bx
      ADD   di,xadd
      MOV   cx,stbredd
      CMP   bx,hojd
      JL    _Rita
      POP   ds
    }
  }
}

void puticon_MF(int n,int x,int y,word DEST,word ICON)
// ritar ut en ikon utan bakgrundsfrg frn banken ICON till skrmen DEST
{
    int ipos,pos;

    ipos=(n-1)*480+4;
    pos=x+(y<<8)+(y<<6);

    asm{
      PUSH  ds
      MOV   ax,[ICON]
      MOV   ds,ax
      MOV   si,ipos
      MOV   ax,[DEST]
      MOV   es,ax
      MOV   di,pos
      CLD
      XOR   bx,bx
      XOR   cx,cx
      JMP   _Rita
      }
     _NoMasking: asm{
      MOVSB
      JMP   _Next
      }
     _Rita: asm{
      MOV   dl,ds:[si]
      CMP   dl,0
      JNZ   _NoMasking
      INC   si
      INC   di
      }
     _Next: asm{
      INC   cx
      CMP   cx,24
      JNZ   _Rita

      XOR   cx,cx
      INC   bx
      ADD   di,296
      CMP   bx,20
      JNZ   _Rita
      POP   ds
    }
}

void loadicons(char *fnamn,byte *ICON,pal &palett)
// laddar in en ICN-fil i ICON med paletten i pal
{
  FILE *fp;

  fp=fopen(fnamn,"rb");
  fread(ICON,48000,1,fp);
  fread(palett,sizeof(pal),1,fp);
  fclose(fp);
}

void loadicons32(char *fnamn,byte *ICON,pal &palette)
// laddar in en ICN-fil i ICON med paletten i pal
{
  FILE *fp;

  fp=fopen(fnamn,"rb");
  fread(ICON,61440,1,fp);
  fread(palette,sizeof(pal),1,fp);
  fclose(fp);
}
