
//   		       	   *** B I G   N O T E ***

// NOTHING IN THIS FILE MAY BE USED WITHOUT GIVING ALL CREDIT TO JOHAN PEITZ

#include <dos.h>

#define KEYINTR 0X09    /* The Keyboard interrupt */

#ifdef __cplusplus
  #define __CPPARGS ...
#else
  #define __CPPARGS
#endif


unsigned char INPUT=0,LASTPUT=0;
unsigned char KEY[128];

void interrupt ( *oldhandler)(__CPPARGS);

void interrupt handler(__CPPARGS)
{
  LASTPUT=INPUT;
  INPUT = inportb(96);
  if (INPUT==224 || INPUT==170 || INPUT==42) INPUT=LASTPUT;

  if (INPUT>127) KEY[INPUT-128]=0;
  else KEY[INPUT]=1;

  outportb(32,32);
}

void saveoldhandler();
void newhandler();
void restorehandler();

void saveoldhandler()
{
  oldhandler = getvect(KEYINTR);
}

void newhandler()
{
  setvect(KEYINTR, handler);
}

void restorehandler()
{
  setvect(KEYINTR, oldhandler);
}


/*

REGULAR KEYS

Scan                                   Scan
Code Key                               Code Key
             
 1   ESC                               44   Z
 2   1                                 45   X
 3   2                                 46   C
 4   3                                 47   V
 5   4                                 48   B
 6   5                                 49   N
 7   6                                 50   M
 8   7                                 51   , <
 9   8                                 52   . >
10   9                                 53   / ?
11   0                                 54   RIGHT SHIFT
12   - _                               55   *            (KEYPAD)
13   = +                               56   LEFT ALT
14   BACKSPACE                         57   SPACEBAR
15   TAB                               58   CAPSLOCK
16   Q                                 59   F1
17   W                                 60   F2
18   E                                 61   F3
19   R                                 62   F4
20   T                                 63   F5
21   Y                                 64   F6
22   U                                 65   F7
23   I                                 66   F8
24   O                                 67   F9
25   P                                 68   F10
26   [ {                               69   NUMLOCK      (KEYPAD)
27   ] }                               70   SCROLL LOCK
28   ENTER (RETURN)                    71   7 HOME       (KEYPAD)
29   LEFT CONTROL                      72   8 UP         (KEYPAD)
30   A                                 73   9 PGUP       (KEYPAD)
31   S                                 74   -            (KEYPAD)
32   D                                 75   4 LEFT       (KEYPAD)
33   F                                 76   5            (KEYPAD)
34   G                                 77   6 RIGHT      (KEYPAD)
35   H                                 78   +            (KEYPAD)
36   J                                 79   1 END        (KEYPAD)
37   K                                 80   2 DOWN       (KEYPAD)
38   L                                 81   3 PGDN       (KEYPAD)
39   ; :                               82   0 INSERT     (KEYPAD)
40   ' "                               83   . DEL        (KEYPAD)
41   ` ~                               87   F11
42   LEFT SHIFT                        88   F12


EXTENDED KEYS

Scan                                   Scan
Code Key                               Code Key
        
28   ENTER        (KEYPAD)              75   LEFT         (NOT KEYPAD)
29   RIGHT CONTROL                      77   RIGHT        (NOT KEYPAD)
42   PRINT SCREEN (SEE TEXT)            79   END          (NOT KEYPAD)
53   /            (KEYPAD)              80   DOWN         (NOT KEYPAD)
55   PRINT SCREEN (SEE TEXT)            81   PAGE DOWN    (NOT KEYPAD)
56   RIGHT ALT                          82   INSERT       (NOT KEYPAD)
71   HOME         (NOT KEYPAD)          83   DELETE       (NOT KEYPAD)
72   UP           (NOT KEYPAD)         111   MACRO
73   PAGE UP      (NOT KEYPAD)

*/