#include <conio.h>

typedef unsigned char byte;
typedef unsigned int word;
typedef unsigned char pal[256][3];

void recallpalette(pal pal1);		     // aktualliserar pal
void storepalette(pal &pal1);		     // sparar aktuell palett i pal
void setcolor(byte,byte,byte,byte);          // stter en viss frg
void getcolor(byte,byte &r,byte &g,byte &b); // ger en viss frg
void setpalette(byte,byte,byte);             // stter hela paletten (rgb)
int fadein(pal pal1);                        // fadar till pal1
int fadeout(byte,byte,byte);		     // fadar till frgen rgb

void recallpalette(pal pal1)
// gr paletten pal1 till aktuell
{
  int c;
  byte r,g,b;

  for(c=0;c<256;c++)
  {
    r=pal1[c][0];
    g=pal1[c][1];
    b=pal1[c][2];
    setcolor(c,r,g,b);
  }
}

void storepalette(pal &pal1)
// sparar aktuell palett i pal1
{
  int c;
  byte r,g,b;

  for(c=0;c<256;c++)
  {
    getcolor(c,r,g,b);
    pal1[c][0]=r;
    pal1[c][1]=g;
    pal1[c][2]=b;
  }
}

void setcolor(byte col,byte r,byte g,byte b)
// bestmmer frgen p 'col' med rd intensitet 'r', grn intensitet 'g'
// och bl intensitet 'b', r,g och b kan vara mellan 0 och 63
  {
    outp (0x03C8,col);
    outp (0x03C9,r);
    outp (0x03C9,g);
    outp (0x03C9,b);
  }

void getcolor(byte col,byte &r,byte &g,byte &b)
// ger frgen p 'col' med rd intensitet 'r', grn intensitet 'g'
// och bl intensitet 'b'
  {
    outp (0x03C7,col);
    r = inp (0x03C9);
    g = inp (0x03C9);
    b = inp (0x03C9);
  }

void setpalette(byte r,byte g,byte b)
// stter hela palette till en och samma frg
{
  for(int c=0;c<256;c++)
    setcolor(c,r,g,b);
}

int fadein(pal pal1)
// fadar ett steg mot pal1, returnerar 0 om ingen frg ndrades
{
  int p=0;
  byte r ,g ,b;
  byte r2,g2,b2;

  for(int c=0;c<256;c++)
  {
    getcolor(c,r,g,b);
    r2=r; g2=g; b2=b;
    if (r<pal1[c][0]) r++;
    if (g<pal1[c][1]) g++;
    if (b<pal1[c][2]) b++;
    if (r>pal1[c][0]) r--;
    if (g>pal1[c][1]) g--;
    if (b>pal1[c][2]) b--;
    setcolor(c,r,g,b);
    if (r!=r2 || g!=g2 || b!=b2) p++;
  }
  return(p);
}

int fadeout(byte r,byte g,byte b)
// fadar ett steg mot frgen rgb, returnerar 0 om ingen frg ndrades
{
  int p=0;
  byte r1,g1,b1;
  byte r2,g2,b2;

  for(int c=0;c<256;c++)
  {
    getcolor(c,r1,g1,b1);
    r2=r1; g2=g1; b2=b1;
    if (r1<r) r1++;
    if (g1<g) g1++;
    if (b1<b) b1++;
    if (r1>r) r1--;
    if (g1>g) g1--;
    if (b1>b) b1--;
    setcolor(c,r1,g1,b1);
    if (r1!=r2 || g1!=g2 || b1!=b2) p++;
  }
  return(p);
}

