// FIX:

// *lives, when dead decrease each pup

#include "gfx.cpp"
#include "opers.cpp"
#include "keyhand2.cpp"
//#include "gamepad.cpp"

#include <stdlib.h>
#include <stdio.h>
#include <dos.h>
#include <iostream.h>

typedef unsigned char byte;
typedef unsigned int word;

const stars=40;
int starx[stars],stary[stars],starspeed[stars];
const baddies=50;
const bullets=30;

const animrate=2;
int animpos=0;

word VR,ICON;
byte *VRblk;
byte *ICblk;
word SYSFNT;                            // ss fonten...
byte far* FNT;

pal PAL;

// bullets
struct skott
{
  int x,y,xspeed,yspeed;
  int power,image,survive,exist;
  int rx,lx,ry,ly;
};
skott bul[bullets];
skott normal,back,sideup,sidedown,miss,kill;

struct enemy
{
  int x,y,image;
  int alive,bang,pattern,speed,count,special,sc;
  int anim,step;
};
enemy fi[baddies];
int animation[7]={0,0,1,2,3,2,1};

int waveexist[5],wavemember[5][5];

// special patterns     (basic pattern, speed, step)
int special1[9]={1,4,60,        //     ____
		 4,3,67,        //     \
		 1,6,999};      //  ____\
int special2[9]={1,4,60,        //  ____
		 5,3,67,        //     /
		 1,4,999};      //    /____
int special3[9]={1,1,40,        //
		 1,0,40,        //  - - -|-
		 1,8,999};      //

// player related
int playerx;
int playery;
int playeranim;
int firedelay;
int firecount;
int dead;
long score;
int speed;
int speeding;
int lives;
int rikt;

// p-ups
int pup;
int pup_spe;
int pup_gun;
int pup_bak;
int pup_sid;
int pup_mis;
int pup_pla;
int pup_mag;

//int shoot=buttonA,choose=buttonC;

void bullettypes()
{
  normal.xspeed=6;
  normal.yspeed=0;
  normal.power=1;
  normal.survive=0;
  normal.image=53;
  normal.exist=1;
  normal.lx=20;
  normal.rx=-6;
  normal.ly=10;
  normal.ry=-10;

  back.xspeed=-5;
  back.yspeed=0;
  back.power=1;
  back.survive=0;
  back.image=72;
  back.exist=1;
  back.lx=-20;
  back.rx=6;
  back.ly=10;
  back.ry=-10;

  sideup.xspeed=0;
  sideup.yspeed=-6;
  sideup.power=0;
  sideup.survive=0;
  sideup.image=63;
  sideup.exist=1;
  sideup.lx=20;
  sideup.rx=-20;
  sideup.ly=10;
  sideup.ry=-10;

  sidedown.xspeed=0;
  sidedown.yspeed=6;
  sidedown.power=0;
  sidedown.survive=0;
  sidedown.image=61;
  sidedown.exist=1;
  sidedown.lx=20;
  sidedown.rx=-20;
  sidedown.ly=10;
  sidedown.ry=-10;

  miss.xspeed=4;
  miss.yspeed=0;
  miss.power=0;
  miss.survive=0;
  miss.image=0;
  miss.exist=1;
  miss.lx=8;
  miss.rx=-8;
  miss.ly=8;
  miss.ry=-8;

  kill.xspeed=7;
  kill.yspeed=0;
  kill.power=5;
  kill.survive=1;
  kill.image=0;
  kill.exist=1;
  kill.lx=20;
  kill.rx=-20;
  kill.ly=20;
  kill.ry=-20;
}

void makestars()
{
  for(int i=0;i<stars;i++)
  {
    starx[i]=random(320);
    stary[i]=random(200);
    starspeed[i]=random(4)+1;
  }
}

void init()
{
  saveoldhandler();
  newhandler();
//  loadgamepad();
  mode(19);
  makevirt(VR,VRblk);
  makeicons(ICON,ICblk);
  makefont(SYSFNT,FNT);
  loadfont("system.fnt",FNT,PAL);

  randomize();
}

void shutdown()
{
  restorehandler();
  killvirt(VRblk);
  killicons(ICblk);
  killfont(FNT);
  mode(3);

  cout << "Score:     " << score << " pts\n\n";
}

void newgame()
{
  loadicons("blocks.icn",ICblk,PAL);
  recallpalette(PAL);
  setcolor(0,0,0,10);

  playerx=20;
  playery=90;
  playeranim=0;
  firedelay=15;
  firecount=0;
  score=0;
  dead=0;
  speed=1;
  speeding=0;
  lives=2;
  rikt=0;

  pup_spe=0;
  pup_gun=0;
  pup_bak=0;
  pup_sid=0;
  pup_mis=0;
  pup_pla=0;
  pup_mag=0;
  pup=1;

  for(int i=0;i<baddies;i++)
  { fi[i].alive=0; fi[i].bang=0; }

  bullettypes();
  for(i=0;i<bullets;i++)
    bul[i].exist=0;

  for(i=0;i<5;i++)
    waveexist[i]=0;

  makestars();
}

void drawscreen()
{
  cls(0,VR);

  for(int i=0;i<stars;i++)
    putpixel(starx[i],stary[i],starspeed[i]<<3-1,VR);

  for(i=0;i<baddies;i++)
    if(fi[i].alive)
      puticon_M(fi[i].image+animation[fi[i].anim],fi[i].x,fi[i].y,VR,ICON);
    else
    if(fi[i].bang)
      puticon_M(85-fi[i].bang,fi[i].x,fi[i].y,VR,ICON);

  for(i=0;i<bullets;i++)
    if(bul[i].exist)
      puticon_M(bul[i].image,bul[i].x,bul[i].y,VR,ICON);

  i=0; if (speeding) i=3;
  if (!dead)
  {
    puticon_M(1+rikt,playerx,playery,VR,ICON);
    puticon_M(4+playeranim+i,playerx-25,playery,VR,ICON);
  }
  else
    puticon_M(78+dead,playerx,playery,VR,ICON);

  for(i=0;i<9;i++)
    puticon_M(99,4+i*24,180,VR,ICON);
  if (pup) puticon_M(100,pup*30-20,180,VR,ICON);
  if (pup_spe<3) puticon_M(92,10,180,VR,ICON);
  if (pup_gun<2) puticon_M(93,40,180,VR,ICON);
  if (!pup_bak) puticon_M(94,70,180,VR,ICON);
  if (pup_sid<2) puticon_M(95,100,180,VR,ICON);
  if (pup_mis<2) puticon_M(96,130,180,VR,ICON);
  if (pup_pla<2) puticon_M(97,160,180,VR,ICON);
  if (!pup_mag) puticon_M(98,190,180,VR,ICON);

  type(score,230,190,31,SYSFNT,VR);

//  if(fired)           // show hit ratio
//    type((int)100*hit/fired,230,180,31,SYSFNT,VR);

  waitvbl();
  screencopy(VR,VGA);
}


void checkhit(int fie)
{
  int w,wmem;

//  check if bullet hits enemy

  for(int b=0;b<bullets;b++)
    if (bul[b].exist && fi[fie].image!=14 && fi[fie].bang==0)
      if (fi[fie].x-bul[b].x<bul[b].lx && fi[fie].x-bul[b].x>bul[b].rx
       && bul[b].y-fi[fie].y<bul[b].ly && bul[b].y-fi[fie].y>bul[b].ry)
      {
	bul[b].exist=bul[b].survive;
	fi[fie].alive-=bul[b].power;
	if(fi[fie].alive<1)
	{
	  fi[fie].alive=0;
	  fi[fie].bang=6;
	  score++;
	  fi[fie].pattern=0;

	// was in wave?
	  for(w=0;w<5;w++)
	    if(waveexist[w])
	      for(wmem=0;wmem<5;wmem++)
		if(wavemember[w][wmem]==fie)
		{
		  wavemember[w][wmem]=255;
		  waveexist[w]--;
		  if(!waveexist[w])
		  {
		    fi[fie].pattern=1;
		    fi[fie].special=0;
		    fi[fie].alive=1;
		    fi[fie].speed=1;
		    fi[fie].image=14;
		    fi[fie].anim=0;
		  }
		}
	}
      }

// check hit between player and asteroid

  if (fi[fie].x-playerx<20 && fi[fie].x-playerx>-20
   && playery-fi[fie].y<12 && playery-fi[fie].y>-12)
    if (fi[fie].image!=14)
      dead=1;
    else
    {
      fi[fie].bang=0;
      fi[fie].alive=0;
      if (!pup) pup=1;
      else add(pup,1,1,7);
    }
}


int findbad()
{
  int ret=-1;

  for(int i=0;i<baddies;i++)
    if(!fi[i].alive && !fi[i].bang)
      ret=i;

  return(ret);
}

void makewave(int w,int y,int p,int s,int im,int xmod,int ymod)
{
  int i,b;

  if (!waveexist[w])
  {
    waveexist[w]=5;
    for(i=0;i<5;i++)
    {
      b=findbad();
      wavemember[w][i]=b;
      fi[b].x=320+xmod*i;
      fi[b].y=y+ymod*i;
      fi[b].alive=3;
      fi[b].speed=1;
      fi[b].sc=0;
      fi[b].count=0;
      fi[b].pattern=p;
      fi[b].special=s;
      fi[b].image=im;
      fi[b].anim=1;
      fi[b].step=5;
    }
  }
}

void makemeteor()
{
  int i=findbad();

  fi[i].x=320;
  fi[i].y=random(180);
  fi[i].alive=1;
  fi[i].speed=random(3)+2;
  fi[i].sc=0;
  fi[i].count=0;
  fi[i].pattern=1;
  fi[i].special=0;
  fi[i].image=15+random(3);
  fi[i].anim=0;
}

void movebaddies()
{
  int w,wmem;

  for(int i=0;i<baddies;i++)
  {
    if ((fi[i].x<-24 || fi[i].y<-20 || fi[i].y<-200)&&fi[i].alive)
    {
     fi[i].alive=0;
  // was in wave?
     for(w=0;w<5;w++)
       if(waveexist[w])
	 for(wmem=0;wmem<5;wmem++)
	   if(wavemember[w][wmem]==i)
	   {
	     wavemember[w][wmem]=255;
	     waveexist[w]--;
	   }
    }

    if (fi[i].x>320 && fi[i].alive) fi[i].x-=fi[i].speed;
    else
    if (fi[i].alive)
    {
// animate?
      if (fi[i].anim && !animpos)
	add(fi[i].anim,1,1,fi[i].step);
// check special pattern
      if (fi[i].special==1)
      {
	fi[i].pattern=special1[fi[i].sc];
	fi[i].speed=special1[fi[i].sc+1];
	fi[i].count++;
	if (fi[i].count==special1[fi[i].sc+2]) { fi[i].count=0; fi[i].sc+=3; }
      }
      if (fi[i].special==2)
      {
	fi[i].pattern=special2[fi[i].sc];
	fi[i].speed=special2[fi[i].sc+1];
	fi[i].count++;
	if (fi[i].count==special2[fi[i].sc+2]) { fi[i].count=0; fi[i].sc+=3; }
      }
      if (fi[i].special==3)
      {
	fi[i].pattern=special3[fi[i].sc];
	fi[i].speed=special3[fi[i].sc+1];
	fi[i].count++;
	if (fi[i].count==special3[fi[i].sc+2]) { fi[i].count=0; fi[i].sc+=3; }
      }

// check movementpattern
      if (!fi[i].pattern);
      if (fi[i].pattern==1) fi[i].x-=fi[i].speed;
      if (fi[i].pattern==2)
      {
	fi[i].x-=fi[i].speed;
	fi[i].y++;
      }
      if (fi[i].pattern==3)
      {
	fi[i].x-=fi[i].speed;
	fi[i].y--;
      }
      if (fi[i].pattern==4)
      {
	fi[i].x+=fi[i].speed;
	fi[i].y++;
      }
      if (fi[i].pattern==5)
      {
	fi[i].x+=fi[i].speed;
	fi[i].y--;
      }
      checkhit(i);
    }
    else
    {
      if (fi[i].bang) fi[i].bang--;
    }
  }
}

int bullet()
{
  int i,bulnr=-1;

  // find free bul

  for(i=0;i<bullets;i++)
    if (!bul[i].exist)
      bulnr=i;

  return(bulnr);
}

void fire()
{
  int b,b2;

  // bullet no1
  b=bullet();
  if (b!=-1 && !pup_mag)
  {
    bul[b]=normal;
    bul[b].x=playerx;
    bul[b].y=playery-1;
    bul[b].power+=pup_pla;
    bul[b].image=53+pup_pla*3;
  }

  if (pup_gun==1 && !pup_mag)
  {
    b=bullet();
    if (b!=-1)
    {
      bul[b]=normal;
      bul[b].x=playerx;
      bul[b].y=playery+2;
      bul[b].power+=pup_pla;
      bul[b].image=53+pup_pla*3;
    }
  }

  if (pup_gun==2 && !pup_mag)
  {
    b=bullet();
    if (b!=-1)
    {
      bul[b]=normal;
      bul[b].x=playerx;
      bul[b].y=playery-2;
      bul[b].yspeed=-1;
      bul[b].image=55+pup_pla*3;
      bul[b].power+=pup_pla;
    }
    b=bullet();
    if (b!=-1)
    {
      bul[b]=normal;
      bul[b].x=playerx;
      bul[b].y=playery;
      bul[b].yspeed=1;
      bul[b].image=54+pup_pla*3;
      bul[b].power+=pup_pla;
    }
  }

  int adj;
  if (pup_sid)
  {
    adj=0; if (pup_mag && pup_sid==2) adj=1;
    b=bullet();
    if (b!=-1)
    {
      bul[b]=sideup;
      bul[b].image+=pup_sid-adj;
      bul[b].power+=pup_sid-adj;
      bul[b].x=playerx;
      bul[b].y=playery;
    }
    b=bullet();
    if (b!=-1)
    {
      bul[b]=sidedown;
      bul[b].image+=pup_sid-adj;
      bul[b].power+=pup_sid-adj;
      bul[b].x=playerx;
      bul[b].y=playery;
    }
  }

  if (pup_mis)
  {
    adj=0; if (pup_mag && pup_mis==2) adj=1;
    b=bullet();
    if (b!=-1)
    {
      bul[b]=miss;
      bul[b].image=67+pup_mis-adj;
      bul[b].power=(pup_mis-adj)<<1;
      bul[b].x=playerx;
      bul[b].y=playery;
      bul[b].yspeed=-4;
    }
    b=bullet();
    if (b!=-1)
    {
      bul[b]=miss;
      bul[b].image=69+pup_mis-adj;
      bul[b].power=(pup_mis-adj)<<1;
      bul[b].x=playerx;
      bul[b].y=playery;
      bul[b].yspeed=4;
    }
  }
  if (pup_mag)
  {
    b=bullet();
    b2=bullet();
    if (b!=-1 && b2!=-1)
    {
      b=bullet();
      bul[b]=kill;
      bul[b].x=playerx+10;
      bul[b].y=playery-10;
      bul[b].image=66;
      b2=bullet();
      bul[b2]=kill;
      bul[b2].x=playerx+10;
      bul[b2].y=playery+9;
      bul[b2].image=67;
    }
  }

  if(pup_bak)
  {
    b=bullet();  	// backbullet
    if (b!=-1)
    {
      bul[b]=back;
      bul[b].x=playerx;
      bul[b].y=playery-1;
    }
  }
}

void movebullets()
{
  int i;

  for(i=0;i<bullets;i++)
    if (bul[i].exist)
    {
      bul[i].x+=bul[i].xspeed;
      bul[i].y+=bul[i].yspeed;
      if (bul[i].x>320 || bul[i].x<-10) bul[i].exist=0;
      if (bul[i].y>200 || bul[i].y<-10) bul[i].exist=0;
    }
}

void movestars()
{
  int i;

  for(i=0;i<stars;i++)
  {
    starx[i]-=starspeed[i];
    if (starx[i]<0 || stary[i]<0)
    {
      starx[i]=319;
      stary[i]=random(200);
      starspeed[i]=random(4)+1;
    }
  }
}

void select()
{
  if (pup==1 && pup_spe<3) { pup_spe++; pup=0; speeding=20; }
  if (pup==2 && pup_gun<2) { pup_gun++; pup=0; }
  if (pup==3 && !pup_bak) { pup_bak++; pup=0; }
  if (pup==4 && pup_sid<2) { pup_sid++; pup=0; }
  if (pup==5 && pup_mis<2) { pup_mis++; pup=0; }
  if (pup==6 && pup_pla<2) { pup_pla++; pup=0; }
  if (pup==7 && !pup_mag) { pup_mag++; pup=0; }
}

void playit()
{
  int s;

  newgame();

  do {
    s=random(100);
    if (s==0) makewave(0,30,0,1,18,10,0);
    if (s==1) makewave(1,150,0,2,18,10,0);
    if (s==2) makewave(2,30,0,3,18,5,30);
    if(!random(10)) makemeteor();

    add(animpos,1,0,animrate);
    if (!animpos) add(playeranim,1,0,2);
    movebaddies();
    movebullets();
    movestars();
    drawscreen();

    if (!dead)
    {
// cheat...
if (KEY==2) pup=1;
if (KEY==3) pup=2;
if (KEY==4) pup=3;
if (KEY==5) pup=4;
if (KEY==6) pup=5;
if (KEY==7) pup=6;
if (KEY==8) pup=7;

      if (speeding) { playerx++; speeding--; }

      rikt=0;
      if (Aleft && playerx>0) playerx-=speed+pup_spe;
      if (Aright && playerx<296) playerx+=speed+pup_spe;
      if (Adown && playery<170) { playery+=speed+pup_spe; rikt=1; }
      if (Aup && playery>0) { playery-=speed+pup_spe; rikt=2; }
      rikt=0;

/*      rikt=0;
      if (padx()==2 && playerx>0) playerx-=speed+pup_spe;
      if (padx()==1 && playerx<296) playerx+=speed+pup_spe;
      if (pady()==1 && playery<170) { playery+=speed+pup_spe; rikt=1; }
      if (pady()==2 && playery>0) { playery-=speed+pup_spe; rikt=2; }
    if (!button(choose) && pup) select();
    if (button(shoot)) firecount=0;
    if (!button(shoot) && !firecount)  fire();
    if (!button(shoot)) add(firecount,1,0,firedelay);
*/
      if (!Lctrl) firecount=0;
      if (Lctrl && !firecount) fire();
      if (Lctrl) add(firecount,1,0,firedelay);
      if (Lalt && pup) select();
    }
    else
      dead++;

  } while(KEY!=1 && dead<7);

  do { waitvbl(); } while (fadeout(63,0,0)>0);
  do { waitvbl(); } while (fadeout(0,0,0)>0);
}

void title()
{
  int ky,i,x,y,c;

  loadcel("title.cel",VRblk,PAL);
  recallpalette(PAL);
  setpalette(0,0,0);
  screencopy(VR,VGA);
  do { waitvbl(); } while (fadein(PAL)>0);

  ky=KEY; while (KEY==ky);

  for(i=0;i<50;i++)
  {
    waitvbl();
    for(x=80;x<237;x++)
      for(y=70;y<117;y++)
      {
	c=(
	   getpixel(x-1,y-1,VGA)+
	   getpixel(x-1,y+1,VGA)+
	   getpixel(x+1,y+1,VGA)+
	   getpixel(x+1,y-1,VGA)+
	   getpixel(x,y,VGA)
	)/5;
	putpixel(x,y,c,VGA);
      }
  }
  do { waitvbl(); } while (fadeout(0,0,0)>0);
}

void main()
{
  init();

//  title();

  playit();

  shutdown();
}
